diff --git a/pgadmin/debugger/frmDebugger.cpp b/pgadmin/debugger/frmDebugger.cpp
index 19f2824..bda8974 100644
--- a/pgadmin/debugger/frmDebugger.cpp
+++ b/pgadmin/debugger/frmDebugger.cpp
@@ -407,10 +834,11 @@ void frmDebugger::OnExit( wxCommandEvent &event )
 void frmDebugger::OnToggleToolBar(wxCommandEvent &event)
 {
 	if (m_viewMenu->IsChecked(MENU_ID_VIEW_TOOLBAR))
-		manager.GetPane(wxT("toolBar")).Show(true);
+		m_manager.GetPane(wxT("toolBar")).Show(true);
 	else
-		manager.GetPane(wxT("toolBar")).Show(false);
-	manager.Update();
+		m_manager.GetPane(wxT("toolBar")).Show(false);
+
+	m_manager.Update();
 }
 
 ////////////////////////////////////////////////////////////////////////////////
@@ -420,10 +848,11 @@ void frmDebugger::OnToggleToolBar(wxCommandEvent &event)
 void frmDebugger::OnToggleStackPane(wxCommandEvent &event)
 {
 	if (m_viewMenu->IsChecked(MENU_ID_VIEW_STACKPANE))
-		manager.GetPane(wxT("stackPane")).Show(true);
+		m_manager.GetPane(wxT("stackPane")).Show(true);
 	else
-		manager.GetPane(wxT("stackPane")).Show(false);
-	manager.Update();
+		m_manager.GetPane(wxT("stackPane")).Show(false);
+
+	m_manager.Update();
 }
 
 ////////////////////////////////////////////////////////////////////////////////
@@ -433,10 +862,11 @@ void frmDebugger::OnToggleStackPane(wxCommandEvent &event)
 void frmDebugger::OnToggleOutputPane(wxCommandEvent &event)
 {
 	if (m_viewMenu->IsChecked(MENU_ID_VIEW_OUTPUTPANE))
-		manager.GetPane(wxT("outputPane")).Show(true);
+		m_manager.GetPane(wxT("outputPane")).Show(true);
 	else
-		manager.GetPane(wxT("outputPane")).Show(false);
-	manager.Update();
+		m_manager.GetPane(wxT("outputPane")).Show(false);
+
+	m_manager.Update();
 }
 
 ////////////////////////////////////////////////////////////////////////////////
@@ -466,18 +896,157 @@ void frmDebugger::OnAuiUpdate(wxAuiManagerEvent &event)
 //    Reset the AUI view to the default
 void frmDebugger::OnDefaultView(wxCommandEvent &event)
 {
-	manager.LoadPerspective(FRMDEBUGGER_DEFAULT_PERSPECTIVE, true);
+	m_manager.LoadPerspective(FRMDEBUGGER_DEFAULT_PERSPECTIVE, true);
 
 	// Reset the captions for the current language
-	manager.GetPane(wxT("toolBar")).Caption(_("Toolbar"));
-	manager.GetPane(wxT("stackPane")).Caption(_("Stack pane"));
-	manager.GetPane(wxT("outputPane")).Caption(_("Output pane"));
+	m_manager.GetPane(wxT("toolBar")).Caption(_("Toolbar"));
+	m_manager.GetPane(wxT("stackPane")).Caption(_("Stack pane"));
+	m_manager.GetPane(wxT("outputPane")).Caption(_("Output pane"));
 
-	// tell the manager to "commit" all the changes just made
-	manager.Update();
+	// tell the m_manager to "commit" all the changes just made
+	m_manager.Update();
 
 	// Sync the View menu options
-	m_viewMenu->Check(MENU_ID_VIEW_TOOLBAR, manager.GetPane(wxT("toolBar")).IsShown());
-	m_viewMenu->Check(MENU_ID_VIEW_STACKPANE, manager.GetPane(wxT("stackPane")).IsShown());
-	m_viewMenu->Check(MENU_ID_VIEW_OUTPUTPANE, manager.GetPane(wxT("outputPane")).IsShown());
+	m_viewMenu->Check(MENU_ID_VIEW_TOOLBAR, m_manager.GetPane(wxT("toolBar")).IsShown());
+	m_viewMenu->Check(MENU_ID_VIEW_STACKPANE, m_manager.GetPane(wxT("stackPane")).IsShown());
+	m_viewMenu->Check(MENU_ID_VIEW_OUTPUTPANE, m_manager.GetPane(wxT("outputPane")).IsShown());
+}
+
+
+void frmDebugger::HighlightLine(int _lineNo)
+{
+	int lineNo = m_codeViewer->MarkerNext(
+	                 0, MARKERINDEX_TO_MARKERMASK( MARKER_CURRENT));
+
+	if (lineNo != -1)
+	{
+		m_codeViewer->MarkerDelete(lineNo, MARKER_CURRENT);
+		m_codeViewer->MarkerDelete(lineNo, MARKER_CURRENT_BG);
+	}
+
+	// Add the current-line indicator to the current line of code
+	m_codeViewer->MarkerAdd(_lineNo, MARKER_CURRENT);
+	m_codeViewer->MarkerAdd(_lineNo, MARKER_CURRENT_BG);
+
+	// Scroll the source code listing (if required) to make sure
+	// that this line of code is visible
+	//
+	// (NOTE: we set the anchor and the caret to the same position to avoid
+	// creating a selection region)
+	int pos = m_codeViewer->PositionFromLine(_lineNo);
+
+	m_codeViewer->SetAnchor(pos);
+	m_codeViewer->SetCurrentPos(pos);
+
+	m_codeViewer->EnsureCaretVisible();
+}
+
+void frmDebugger::DisplaySource(dbgCachedStack &_cached)
+{
+	dbgModel *model = m_controller->GetModel();
+
+	m_codeViewer->SetFocus();
+
+	if (model->RequireDisplayUpdate())
+	{
+		ctlVarWindow *varWin = NULL;
+		if ((varWin = GetVarWindow(false)) != NULL)
+		{
+			varWin->DelVar();
+		}
+		if ((varWin = GetParamWindow(false)) != NULL)
+		{
+			varWin->DelVar();
+		}
+		if ((varWin = GetPkgVarWindow(false)) != NULL)
+		{
+			varWin->DelVar();
+		}
+
+		model->GetDisplayedFunction() = _cached.m_func;
+		model->GetDisplayedPackage() = _cached.m_pkg;
+
+		// Now erase any old code and write out the new listing
+		m_codeViewer->SetReadOnly(false);
+
+		m_codeViewer->SetText(_cached.m_source);
+		m_codeViewer->Colourise(0, _cached.m_source.Length());
+
+		m_codeViewer->SetReadOnly(true);
+	}
+	HighlightLine(model->GetCurrLineNo());
+}
+
+
+void frmDebugger::SetStatusText(const wxString &_status)
+{
+	m_statusBar->SetStatusText(_status, 1);
+}
+
+
+void frmDebugger::CloseProgressBar()
+{
+	if (m_progressBar)
+	{
+		m_progressBar->Close();
+		delete m_progressBar;
+		m_progressBar = NULL;
+	}
+}
+
+
+void frmDebugger::LaunchWaitingDialog(const wxString &msg)
+{
+	dbgModel *model = m_controller->GetModel();
+	wxString strStatus,
+	         strTargetPid = model->GetTargetPid(),
+	         strTarget    = model->GetTarget()->GetQualifiedName();
+
+	if (msg.IsEmpty())
+	{
+		if (strTargetPid != wxT("NULL"))
+		{
+			strStatus =
+			    wxString::Format(
+			        _("Waiting for the session (pid:%s) to invoke the specified targets."),
+			        strTargetPid.c_str());
+		}
+		else
+		{
+			strStatus =
+			    wxString::Format(
+			        _("Waiting for another session to invoke the target - \"%s\""), strTarget.c_str());
+		}
+	}
+	else
+	{
+		strStatus = msg;
+	}
+
+	m_statusBar->SetStatusText(strStatus, 1);
+
+	// NOTE: the waiting-dialog takes forever to appear running a remote X session so you can disable it by defining the following env. variable
+	if(getenv("SUPPRESS_WAIT_DIALOG"))
+	{
+		m_progressBar = NULL;
+	}
+	else
+	{
+		m_progressBar =
+		    new wxProgressDialog(_("Waiting for target"), strStatus, 100, this,
+		                         wxPD_SMOOTH | wxPD_CAN_ABORT | wxPD_ELAPSED_TIME );
+
+		m_timer.Start(500);    // 2 clock ticks per second
+	}
+}
+
+void frmDebugger::OnTimer(wxTimerEvent &_ev)
+{
+	if (m_progressBar)
+	{
+		if (m_progressBar->Pulse() == false)
+		{
+			Close();
+		}
+	}
 }
diff --git a/pgadmin/debugger/module.mk b/pgadmin/debugger/module.mk
index 863ae8e..46fe479 100644
--- a/pgadmin/debugger/module.mk
+++ b/pgadmin/debugger/module.mk
@@ -10,17 +10,15 @@
 #######################################################################
 
 pgadmin3_SOURCES += \
-	debugger/ctlCodeWindow.cpp \
 	debugger/ctlMessageWindow.cpp \
 	debugger/ctlResultGrid.cpp \
 	debugger/ctlStackWindow.cpp \
 	debugger/ctlTabWindow.cpp \
 	debugger/ctlVarWindow.cpp \
 	debugger/dbgBreakPoint.cpp \
-	debugger/dbgDbResult.cpp \
- 	debugger/dbgPgConn.cpp \
-	debugger/dbgPgThread.cpp \
-	debugger/dbgResultset.cpp \
+	debugger/dbgController.cpp \
+	debugger/dbgEvents.cpp \
+	debugger/dbgModel.cpp \
  	debugger/dbgTargetInfo.cpp \
 	debugger/debugger.cpp \
 	debugger/dlgDirectDbg.cpp \
diff --git a/pgadmin/dlg/dlgClasses.cpp b/pgadmin/dlg/dlgClasses.cpp
index 2c764b1..aaeb626 100644
--- a/pgadmin/dlg/dlgClasses.cpp
+++ b/pgadmin/dlg/dlgClasses.cpp
@@ -491,7 +491,11 @@ void ExecutionDialog::Abort()
 	if (thread)
 	{
 		if (thread->IsRunning())
-			thread->Delete();
+		{
+			thread->CancelExecution();
+			thread->Wait();
+		}
+
 		delete thread;
 		thread = 0;
 	}
diff --git a/pgadmin/frm/frmEditGrid.cpp b/pgadmin/frm/frmEditGrid.cpp
index 88efe55..8df535b 100644
--- a/pgadmin/frm/frmEditGrid.cpp
+++ b/pgadmin/frm/frmEditGrid.cpp
@@ -1524,7 +1524,10 @@ void frmEditGrid::Abort()
 	{
 		SetStatusText(_("aborting."), 0);
 		if (thread->IsRunning())
-			thread->Delete();
+		{
+			thread->CancelExecution();
+			thread->Wait();
+		}
 		delete thread;
 		thread = 0;
 	}
diff --git a/pgadmin/frm/frmQuery.cpp b/pgadmin/frm/frmQuery.cpp
index 4e30242..fcfc15f 100644
--- a/pgadmin/frm/frmQuery.cpp
+++ b/pgadmin/frm/frmQuery.cpp
@@ -159,7 +159,7 @@ BEGIN_EVENT_TABLE(frmQuery, pgFrame)
 	EVT_TIMER(CTL_TIMERSIZES,       frmQuery::OnAdjustSizesTimer)
 	EVT_TIMER(CTL_TIMERFRM,         frmQuery::OnTimer)
 // These fire when the queries complete
-	EVT_MENU(QUERY_COMPLETE,        frmQuery::OnQueryComplete)
+	EVT_PGQUERYRESULT(QUERY_COMPLETE, frmQuery::OnQueryComplete)
 	EVT_MENU(PGSCRIPT_COMPLETE,     frmQuery::OnScriptComplete)
 	EVT_AUINOTEBOOK_PAGE_CHANGED(CTL_NTBKCENTER, frmQuery::OnChangeNotebook)
 	EVT_SPLITTER_SASH_POS_CHANGED(GQB_HORZ_SASH, frmQuery::OnResizeHorizontally)
@@ -2415,7 +2415,7 @@ void frmQuery::execQuery(const wxString &query, int resultToRetrieve, bool singl
 
 
 // When the query completes, it raises an event which we process here.
-void frmQuery::OnQueryComplete(wxCommandEvent &ev)
+void frmQuery::OnQueryComplete(pgQueryResultEvent &ev)
 {
 	QueryExecInfo *qi = (QueryExecInfo *)ev.GetClientData();
 
@@ -2548,7 +2548,7 @@ void frmQuery::OnQueryComplete(wxCommandEvent &ev)
 	else
 	{
 		done = true;
-		outputPane->SetSelection(0);
+		outputPane->SetSelection(0);		
 		long rowsTotal = sqlResult->NumRows();
 
 		if (qi->toFileExportForm)
diff --git a/pgadmin/include/db/module.mk b/pgadmin/include/db/module.mk
index ae79345..03fefa1 100644
--- a/pgadmin/include/db/module.mk
+++ b/pgadmin/include/db/module.mk
@@ -12,9 +12,9 @@
 pgadmin3_SOURCES += \
 	  include/db/pgConn.h \
 	  include/db/pgQueryThread.h \
+	  include/db/pgQueryResultEvent.h \
 	  include/db/pgSet.h
 
-
 EXTRA_DIST += \
     include/db/module.mk
 
diff --git a/pgadmin/include/db/pgConn.h b/pgadmin/include/db/pgConn.h
index f58cb81..c5d3e10 100644
--- a/pgadmin/include/db/pgConn.h
+++ b/pgadmin/include/db/pgConn.h
@@ -24,33 +24,33 @@
 // status enums
 enum
 {
-    PGCONN_OK = CONNECTION_OK,
-    PGCONN_BAD = CONNECTION_BAD,
-    PGCONN_REFUSED,
-    PGCONN_DNSERR,
-    PGCONN_ABORTED,     // connect user aborted
-    PGCONN_BROKEN       // tcp/pipe broken
+	PGCONN_OK = CONNECTION_OK,
+	PGCONN_BAD = CONNECTION_BAD,
+	PGCONN_REFUSED,
+	PGCONN_DNSERR,
+	PGCONN_ABORTED,     // connect user aborted
+	PGCONN_BROKEN       // tcp/pipe broken
 };
 
 enum
 {
-    PGCONN_EMPTY_QUERY = PGRES_EMPTY_QUERY,
-    PGCONN_COMMAND_OK = PGRES_COMMAND_OK,
-    PGCONN_TUPLES_OK = PGRES_TUPLES_OK,
-    PGCONN_COPY_OUT = PGRES_COPY_OUT,
-    PGCONN_COPY_IN = PGRES_COPY_IN,
-    PGCONN_BAD_RESPONSE = PGRES_BAD_RESPONSE,
-    PGCONN_NONFATAL_ERROR = PGRES_NONFATAL_ERROR,
-    PGCONN_FATAL_ERROR = PGRES_FATAL_ERROR
+	PGCONN_EMPTY_QUERY = PGRES_EMPTY_QUERY,
+	PGCONN_COMMAND_OK = PGRES_COMMAND_OK,
+	PGCONN_TUPLES_OK = PGRES_TUPLES_OK,
+	PGCONN_COPY_OUT = PGRES_COPY_OUT,
+	PGCONN_COPY_IN = PGRES_COPY_IN,
+	PGCONN_BAD_RESPONSE = PGRES_BAD_RESPONSE,
+	PGCONN_NONFATAL_ERROR = PGRES_NONFATAL_ERROR,
+	PGCONN_FATAL_ERROR = PGRES_FATAL_ERROR
 };
 
 enum
 {
-    PGCONN_TXSTATUS_IDLE = PQTRANS_IDLE,
-    PGCONN_TXSTATUS_ACTIVE = PQTRANS_ACTIVE,
-    PGCONN_TXSTATUS_INTRANS = PQTRANS_INTRANS,
-    PGCONN_TXSTATUS_INERROR = PQTRANS_INERROR,
-    PGCONN_TXSTATUS_UNKNOWN = PQTRANS_UNKNOWN
+	PGCONN_TXSTATUS_IDLE = PQTRANS_IDLE,
+	PGCONN_TXSTATUS_ACTIVE = PQTRANS_ACTIVE,
+	PGCONN_TXSTATUS_INTRANS = PQTRANS_INTRANS,
+	PGCONN_TXSTATUS_INERROR = PQTRANS_INERROR,
+	PGCONN_TXSTATUS_UNKNOWN = PQTRANS_UNKNOWN
 };
 
 // Our version of a pgNotify
@@ -77,8 +77,9 @@ typedef struct pgError
 	wxString source_line;
 	wxString source_function;
 	wxString formatted_msg;
-} pgError;
 
+	void SetError(PGresult *_res = NULL, wxMBConv *_conv = NULL);
+} pgError;
 
 class pgConn
 {
@@ -110,7 +111,7 @@ public:
 	bool GetIsGreenplum();
 	wxString EncryptPassword(const wxString &user, const wxString &password);
 	wxString qtDbString(const wxString &value);
-	pgConn *Duplicate();
+	pgConn *Duplicate(const wxString &_appName = wxT(""));
 
 	static void ExamineLibpqVersion();
 	static double GetLibpqVersion()
@@ -126,8 +127,10 @@ public:
 	void Close();
 	bool Reconnect();
 	bool ExecuteVoid(const wxString &sql, bool reportError = true);
-	wxString ExecuteScalar(const wxString &sql);
-	pgSet *ExecuteSet(const wxString &sql);
+	wxString ExecuteScalar(const wxString &sql, bool reportError = true);
+	pgSet *ExecuteSet(const wxString &sql, bool reportError = true);
+	void CancelExecution(void);
+
 	wxString GetHostAddr() const
 	{
 		return save_hostaddr;
@@ -257,12 +260,16 @@ public:
 	bool TableHasColumn(wxString schemaname, wxString tblname, const wxString &colname);
 
 protected:
-	PGconn *conn;
+	PGconn   *conn;
+	PGcancel *m_cancelConn;
+	wxMutex   m_cancelConnMutex;
 	int lastResultStatus;
 
 	int connStatus;
 
 	void SetLastResultError(PGresult *res, const wxString &msg = wxEmptyString);
+	void SetConnCancel(void);
+	void ResetConnCancel(void);
 	pgError lastResultError;
 
 	wxMBConv *conv;
diff --git a/pgadmin/include/db/pgQueryThread.h b/pgadmin/include/db/pgQueryThread.h
index a03a32a..59bebf7 100644
--- a/pgadmin/include/db/pgQueryThread.h
+++ b/pgadmin/include/db/pgQueryThread.h
@@ -12,59 +12,271 @@
 #ifndef PGQUERYTHREAD_H
 #define PGQUERYTHREAD_H
 
+#include "wx/wx.h"
+#include "wx/event.h"
+#include "db/pgConn.h"
+
+// Forward declaration
 class pgSet;
+class pgQueryThread;
+class pgBatchQuery;
+
+// Support for the IN & INOUT parameters type
+class pgParam : public wxObject
+{
+public:
+	enum
+	{
+		PG_PARAM_IN       = 1,
+		PG_PARAM_OUT      = 2,
+		PG_PARAM_INOUT    = 3,
+		PG_PARAM_VARIADIC = 4,
+		PG_PARAM_TABLE    = 5
+	};
+
+	// Any data
+	//
+	// This constructor won't call the functions - 'htonl' or 'htons'
+	// It will be the responsibility of the caller to take care
+	// to call 'htonl' or 'htons' depending on requirements.
+	//
+	// NOTE:
+	// This data will be owned by pgParam object and will be released.
+	pgParam(Oid _type, void *_val, int _len, short mode = PG_PARAM_IN);
+
+	// wxString data
+	pgParam(Oid _type, wxString *_val, wxMBConv *_conv = NULL,
+	        short mode = PG_PARAM_IN);
+
+	~pgParam();
+
+	// Returns 0 for text type and 1 for otherwise
+	int   GetFormat();
+
+	Oid   GetType()
+	{
+		return m_type;
+	}
+	short GetMode()
+	{
+		return m_mode;
+	}
+
+protected:
+	Oid    m_type;
+	void  *m_val;
+	int    m_len;
+	short  m_format;
+	// Modes are required by EnterpriseDB's callable statement
+	short  m_mode;
+
+	// Do not allow copy construction and shadow-copy
+	// to avoid ownership
+	// Force to use an pointer
+	pgParam(const pgParam &)
+	{
+		wxASSERT(0);
+	}
+	pgParam &operator= (const pgParam &)
+	{
+		wxASSERT(0);
+	}
+
+	friend class pgConn;
+	friend class pgQueryThread;
+};
+
+WX_DEFINE_ARRAY_PTR(pgParam *, pgParamsArray);
+
+class pgBatchQuery : public wxObject
+{
+public:
+	pgBatchQuery(const wxString &_query, pgParamsArray *_params = NULL,
+	             long _eventId = -1, void *_data = NULL, bool _useCallable = false,
+	             int _resultToRetrieve = 0)
+		: m_query(_query), m_params(_params), m_eventID(_eventId), m_data(_data),
+		  m_useCallable(_useCallable), m_resToRetrieve(_resultToRetrieve),
+		  m_returnCode(-1), m_resultSet(NULL), m_rowsInserted(-1), m_insertedOid(-1)
+	{
+		// Do not honour the empty query string
+		wxASSERT(!_query.IsEmpty());
+	}
+	~pgBatchQuery();
+
+	bool            Release();
+
+	pgSet          *ResultSet()
+	{
+		return m_resultSet;
+	}
+
+	int             ReturnCode()
+	{
+		return m_returnCode;
+	}
+
+	const wxString &GetMessage()
+	{
+		return m_message;
+	}
+
+	long            RowInserted()
+	{
+		return m_rowsInserted;
+	}
+
+	const wxString &GetErrorMessage();
+
+protected:
+	wxString           m_query;         // Query
+	pgParamsArray     *m_params;        // parameters
+	long               m_eventID;       // Event ID
+	void              *m_data;          // Data to be send with event
+	bool               m_useCallable;   // Use EnterpriseDB callable statement if possible
+	int                m_resToRetrieve; // Which result to be retrieved
+	int                m_returnCode;    // Return code
+	pgSet             *m_resultSet;     // Result-Set
+	long               m_rowsInserted;  // No of rows inserted
+	Oid                m_insertedOid;   // Inserted Oid
+	wxString           m_message;       // Message generated during query execution
+	pgError            m_err;           // Error
+
+private:
+	// Do not allow copy construction and '=' operator (shadow copying)
+	// to avoid ownership of parameters and result-set
+	//
+	// This will force this class to be used as an pointer only.
+	pgBatchQuery(const pgBatchQuery &)
+	{
+		wxASSERT(0);
+	}
+	pgBatchQuery &operator= (const pgBatchQuery &)
+	{
+		wxASSERT(0);
+	}
+
+	friend class pgQueryThread;
+};
+WX_DEFINE_ARRAY_PTR(pgBatchQuery *, pgBatchQueryArray);
 
 class pgQueryThread : public wxThread
 {
 public:
-	pgQueryThread(pgConn *_conn, const wxString &qry, int resultToRetrieve = -1, wxWindow *_caller = 0, long eventId = 0, void *_data = 0);
+	// For running a single query (Used by few components)
+	pgQueryThread(pgConn *_conn, const wxString &qry, int resultToRetrieve = -1,
+	              wxWindow *_caller = 0, long eventId = 0, void *_data = 0);
+
+	// Support for multiple queries support
+	pgQueryThread(pgConn *_conn, wxEvtHandler *_caller = NULL,
+	              PQnoticeProcessor _processor = NULL, void *_noticeHandler = NULL);
+
 	~pgQueryThread();
 
+	bool HasMultipleQueriesSupport()
+	{
+		return m_multiQueries;
+	}
+
+	bool SupportCallableStatement()
+	{
+		return m_useCallable;
+	}
+
+	void AddQuery(
+	    const wxString &_qry, pgParamsArray *_params = NULL,
+	    long _eventId = 0, void *_data = NULL, bool _useCallable = false,
+	    int _resultToRetrieve = -1);
+
 	virtual void *Entry();
-	bool DataValid() const
+	bool DataValid(int _idx = -1) const
 	{
-		return dataSet != NULL;
+		if (_idx == -1)
+			_idx = m_currIndex;
+		return (_idx >= 0 && _idx > m_currIndex ? false : (m_queries[_idx]->m_resultSet != NULL));
 	}
-	pgSet *DataSet()
+
+	pgConn *GetConn()
+	{
+		return m_conn;
+	}
+
+	pgSet *DataSet(int _idx = -1)
+	{
+		if (_idx == -1)
+			_idx = m_currIndex;
+		return (_idx >= 0 && _idx > m_currIndex ? NULL : m_queries[_idx]->m_resultSet);
+	}
+
+	int ReturnCode(int _idx = -1) const
+	{
+		if (_idx == -1)
+			_idx = m_currIndex;
+		return (_idx >= 0 && _idx > m_currIndex ? -1 : m_queries[_idx]->m_returnCode);
+	}
+
+	long RowsInserted(int _idx = -1) const
 	{
-		return dataSet;
+		if (_idx == -1)
+			_idx = m_currIndex;
+		return (_idx >= 0 && _idx > m_currIndex ? -1L : m_queries[_idx]->m_rowsInserted);
 	}
-	int ReturnCode() const
+
+	Oid InsertedOid(int _idx = -1) const
 	{
-		return rc;
+		if (_idx == -1)
+			_idx = m_currIndex;
+		return (_idx >= 0 && _idx > m_currIndex ? -1L : m_queries[_idx]->m_insertedOid);
 	}
-	long RowsInserted() const
+
+	inline void CancelExecution()
+	{
+		m_cancelled = true;
+	}
+
+	inline size_t GetNumberQueries()
 	{
-		return rowsInserted;
+		return m_queries.GetCount();
 	}
-	OID InsertedOid() const
+
+	size_t QueriesExecuted()
 	{
-		return insertedOid;
+		return m_currIndex + 1;
 	}
-	wxString GetMessagesAndClear();
-	void appendMessage(const wxString &str);
+
+	wxString GetMessagesAndClear(int _idx = -1);
+	void AppendMessage(const wxString &_str);
+
+	int DeleteReleasedQueries();
 
 private:
-	int rc;
-	int resultToRetrieve;
-	long rowsInserted;
-	OID insertedOid;
-
-	wxString query;
-	pgConn *conn;
-	PGresult *result;
-	wxString messages;
-	pgSet *dataSet;
-	wxCriticalSection criticalSection;
-
-	void *data;
-	wxWindow *caller;
-	long eventId;
-
-	int execute();
-	int raiseEvent(int retval = 0);
-
-	void appendMessageRaw(const wxString &str);
+	int Execute();
+	int RaiseEvent(int _retval = 0);
+
+	// Queries to be exectued
+	pgBatchQueryArray  m_queries;
+	// Current running query index
+	int                m_currIndex;
+	// Connection object
+	pgConn            *m_conn;
+	// Execution cancelled?
+	bool               m_cancelled;
+	// Does this thread support multiple queries
+	bool               m_multiQueries;
+	// Use EDB callable statement (if available and require)
+	bool               m_useCallable;
+	// Is executing a query
+	bool               m_executing;
+	// Queries are being accessed at this time
+	wxMutex            m_queriesLock;
+	// When one thread is accesing messages, other should not be able to access it
+	wxCriticalSection  m_criticalSection;
+	// Event Handler
+	wxEvtHandler      *m_caller;
+	// Database server notice-processor
+	PQnoticeProcessor  m_processor;
+	// Notice Handler
+	void              *m_noticeHandler;
+
 };
 
 #endif
diff --git a/pgadmin/include/db/pgSet.h b/pgadmin/include/db/pgSet.h
index f6543b1..9a5c7b5 100644
--- a/pgadmin/include/db/pgSet.h
+++ b/pgadmin/include/db/pgSet.h
@@ -131,6 +131,14 @@ public:
 		return conv;
 	}
 
+	wxString GetCommandStatus() const
+	{
+		if (res)
+		{
+			return wxString(PQcmdStatus(res), conv);
+		}
+		return wxEmptyString;
+	}
 
 protected:
 	pgConn *conn;
diff --git a/pgadmin/include/debugger/ctlMessageWindow.h b/pgadmin/include/debugger/ctlMessageWindow.h
index aaab315..f588880 100644
--- a/pgadmin/include/debugger/ctlMessageWindow.h
+++ b/pgadmin/include/debugger/ctlMessageWindow.h
@@ -23,21 +23,14 @@
 
 class ctlMessageWindow : public wxTextCtrl
 {
-	DECLARE_CLASS( ctlMessageWindow )
+	DECLARE_CLASS(ctlMessageWindow)
 
 public:
-	ctlMessageWindow( wxWindow *parent, wxWindowID id );
+	ctlMessageWindow(wxWindow *parent, wxWindowID id);
 
-	void	addMessage( wxString message );	// Add a message to the window
-	void	delMessage( const char *name = NULL );								     // Remove a message from the window
-	wxString	getMessage( int row );
-
-private:
-
-	typedef struct
-	{
-		int	m_row;		// Row number for this variable/grid cell
-	} gridCell;
+	void     AddMessage(wxString message);	// Add a message to the window
+	void     DelMessage(const char *name = NULL);								     // Remove a message from the window
+	wxString GetMessage(int row);
 };
 
 #endif
diff --git a/pgadmin/include/debugger/ctlResultGrid.h b/pgadmin/include/debugger/ctlResultGrid.h
index fa7590e..76fdc28 100644
--- a/pgadmin/include/debugger/ctlResultGrid.h
+++ b/pgadmin/include/debugger/ctlResultGrid.h
@@ -25,12 +25,13 @@
 
 class ctlResultGrid : public wxGrid
 {
-	DECLARE_CLASS( ctlResultGrid )
+	DECLARE_CLASS(ctlResultGrid)
 
 public:
-	ctlResultGrid( wxWindow *parent, wxWindowID id );
+	ctlResultGrid(wxWindow *parent, wxWindowID id);
 
-	void	fillGrid( PGresult *result );	// Copy a result set into the grid
+	// Copy a result set into the grid
+	void	FillResult(pgSet *set);
 };
 
 #endif
diff --git a/pgadmin/include/debugger/ctlStackWindow.h b/pgadmin/include/debugger/ctlStackWindow.h
index b6d94c0..cf64f81 100644
--- a/pgadmin/include/debugger/ctlStackWindow.h
+++ b/pgadmin/include/debugger/ctlStackWindow.h
@@ -36,8 +36,8 @@ class ctlStackWindow : public wxListBox
 public:
 
 	ctlStackWindow(wxWindow *parent, wxWindowID id, const wxPoint &pos = wxDefaultPosition, const wxSize &size = wxDefaultSize, long style = wxCLIP_CHILDREN | wxSW_3D, const wxString &name = wxT( "stackWindow" ));
-	void clear();											// Remove all frames from the stack trace
-	void setStack(const wxArrayString &stack);			// Add an array of frames to the stack trace
+	void ClearStack();											// Remove all frames from the stack trace
+	void SetStack(const wxArrayString &stack);			// Add an array of frames to the stack trace
 };
 
 #endif
diff --git a/pgadmin/include/debugger/ctlTabWindow.h b/pgadmin/include/debugger/ctlTabWindow.h
index 7d09f9b..684b664 100644
--- a/pgadmin/include/debugger/ctlTabWindow.h
+++ b/pgadmin/include/debugger/ctlTabWindow.h
@@ -32,34 +32,37 @@
 #include "debugger/ctlStackWindow.h"
 #include "debugger/ctlResultGrid.h"
 
-WX_DECLARE_HASH_MAP( int, int, wxIntegerHash, wxIntegerEqual, wsTabHash );
+WX_DECLARE_HASH_MAP(int, int, wxIntegerHash, wxIntegerEqual, wsTabHash);
 
 class ctlTabWindow : public ctlAuiNotebook
 {
-	DECLARE_CLASS( ctlTabWindow )
+	DECLARE_CLASS(ctlTabWindow)
 
 public:
 
-	ctlTabWindow(wxWindow *parent, wxWindowID id, const wxPoint &pos = wxDefaultPosition, const wxSize &size = wxDefaultSize, long style = wxCLIP_CHILDREN | wxSW_3D, const wxString &name = wxT( "layoutWindow" ));
+	ctlTabWindow(wxWindow *parent, wxWindowID id,
+	             const wxPoint &pos = wxDefaultPosition, const wxSize &size = wxDefaultSize,
+	             long style = wxCLIP_CHILDREN | wxSW_3D,
+	             const wxString &name = wxT("layoutWindow"));
 
-	ctlVarWindow	*getVarWindow( bool create = true );		// Returns a pointer to the local-variables window (creates it if requested)
-	ctlVarWindow	*getPkgVarWindow( bool create = true );	// Returns a pointer to the package-variables window (creates it if requested)
-	ctlVarWindow	*getParamWindow( bool create = true );		// Returns a pointer to the parameters window (creates it if requested)
+	ctlVarWindow      *GetVarWindow(bool create = true);    // Returns a pointer to the local-variables window (creates it if requested)
+	ctlVarWindow      *GetPkgVarWindow(bool create = true); // Returns a pointer to the package-variables window (creates it if requested)
+	ctlVarWindow      *GetParamWindow(bool create = true);  // Returns a pointer to the parameters window (creates it if requested)
 
-	ctlResultGrid	*getResultWindow( void );					// Returns a pointer to the result window (creates it if necessary)
-	ctlStackWindow	*getStackWindow( void );					// Returns a pointer to the stack-trace window (creates it if necessary)
-	ctlMessageWindow *getMessageWindow( void );					// Returns a pointer to the DBMS messages window (creates it if necessary)
-	void	selectTab( wxWindowID id );
+	ctlResultGrid     *GetResultWindow();					// Returns a pointer to the result window (creates it if necessary)
+	ctlStackWindow    *GetStackWindow();                    // Returns a pointer to the stack-trace window (creates it if necessary)
+	ctlMessageWindow  *GetMessageWindow();                  // Returns a pointer to the DBMS messages window (creates it if necessary)
+	void	           SelectTab(wxWindowID id);
 
 private:
-	ctlResultGrid	*m_resultWindow;	// Displays the result set from a query
-	ctlVarWindow	*m_varWindow;		// Displays the local variables when debugging a PL function
-	ctlVarWindow	*m_pkgVarWindow;	// Displays the package variables when debugging a PL function
-	ctlStackWindow	*m_stackWindow;		// Displays the current call stack
-	ctlVarWindow	*m_paramWindow;		// Displays the parameters when debugging a PL function
-	ctlMessageWindow	*m_messageWindow;	// Displays the DBMS messages when debugging a PL function
+	ctlResultGrid    *m_resultWindow;  // Displays the result set from a query
+	ctlVarWindow     *m_varWindow;     // Displays the local variables when debugging a PL function
+	ctlVarWindow     *m_pkgVarWindow;  // Displays the package variables when debugging a PL function
+	ctlStackWindow   *m_stackWindow;   // Displays the current call stack
+	ctlVarWindow     *m_paramWindow;   // Displays the parameters when debugging a PL function
+	ctlMessageWindow *m_messageWindow; // Displays the DBMS messages when debugging a PL function
 
-	wsTabHash	*m_tabMap;		// Map window ID's to tab numbers;
+	wsTabHash        *m_tabMap;        // Map window ID's to tab numbers;
 };
 
 #endif
diff --git a/pgadmin/include/debugger/ctlVarWindow.h b/pgadmin/include/debugger/ctlVarWindow.h
index 0d2a4a2..665531f 100644
--- a/pgadmin/include/debugger/ctlVarWindow.h
+++ b/pgadmin/include/debugger/ctlVarWindow.h
@@ -35,38 +35,40 @@
 
 class ctlVarWindow : public wxGrid
 {
-	DECLARE_CLASS( ctlVarWindow )
+	DECLARE_CLASS(ctlVarWindow)
 
 public:
-	ctlVarWindow( wxWindow *parent, wxWindowID id );
+	ctlVarWindow(wxWindow *parent, wxWindowID id);
 
-	void	addVar( wxString name, wxString value, wxString type, bool readOnly );	// Add a variable to the window
-	void	delVar( wxString name = wxEmptyString);								    // Remove a variable from the window
-	wxString	getVarName( int row );
-	wxString	getVarValue( int row );
+	// Add a variable to the window
+	void AddVar(wxString name, wxString value, wxString type, bool readOnly);
+	// Remove a variable from the window
+	void DelVar(wxString name = wxEmptyString);
+
+	wxString GetVarName(int row);
+	wxString GetVarValue(int row);
 
 private:
 
 	// The content of a grid cell is defined by the gridCell structure
-
 	typedef struct
 	{
-		int		m_row;	 // Row number for this variable/grid cell
-		wxString	m_value; // Variable value
-		wxString	m_type;	 // Variable type
+		int      m_row;   // Row number for this variable/grid cell
+		wxString m_value; // Variable value
+		wxString m_type;  // Variable type
 	} gridCell;
 
 	enum
 	{
-	    COL_NAME = 0,		// Column 0 contains the variable name
-	    COL_TYPE,		// This column contains the variable type
-	    COL_VALUE		// This column contains the variable value
+		COL_NAME = 0,		// Column 0 contains the variable name
+		COL_TYPE,		// This column contains the variable type
+		COL_VALUE		// This column contains the variable value
 	};
 
 	// The m_cells hash translates variable names into gridCell references
 public:
-	WX_DECLARE_STRING_HASH_MAP( gridCell, wsCellHash );
-	WX_DECLARE_HASH_SET( wxString, wxStringHash, wxStringEqual, wsStringSet );
+	WX_DECLARE_STRING_HASH_MAP(gridCell, wsCellHash);
+	WX_DECLARE_HASH_SET(wxString, wxStringHash, wxStringEqual, wsStringSet);
 
 private:
 	wsStringSet	m_hiddenNames;	// List of hidden variable names
diff --git a/pgadmin/include/debugger/dbgBreakPoint.h b/pgadmin/include/debugger/dbgBreakPoint.h
index b327504..486038a 100644
--- a/pgadmin/include/debugger/dbgBreakPoint.h
+++ b/pgadmin/include/debugger/dbgBreakPoint.h
@@ -21,36 +21,29 @@
 class dbgBreakPoint
 {
 public:
+	dbgBreakPoint(const wxString &_funcOid, const wxString &_pkgOid = wxT("0"),
+	              const wxString &_lineNo = wxT("NULL"))
+		: m_func(_funcOid), m_pkg(_pkgOid), m_lineNo(_lineNo) {}
 
-	enum eTargetType
+	wxString    &GetFunctionOid()
 	{
-	    TRIGGER,
-	    FUNCTION,
-	    PROCEDURE,
-	    OID
-	};
-
-	dbgBreakPoint(eTargetType targetType, const wxString &target, const wxString &process ): m_targetType(targetType), m_target(target), m_targetProcess(process) {}
-
-	eTargetType   getTargetType()
-	{
-		return( m_targetType );
+		return m_func;
 	}
-	wxString     &getTarget()
+	wxString    &GetPackageOid()
 	{
-		return( m_target );
+		return m_pkg;
 	}
-	wxString     &getTargetProcess()
+	wxString    &GetLineNo()
 	{
-		return( m_targetProcess );
+		return m_lineNo;
 	}
-private:
-	eTargetType 	m_targetType;
-	wxString	m_target;
-	wxString	m_targetProcess;
 
+private:
+	wxString    m_func;
+	wxString    m_pkg;
+	wxString    m_lineNo;
 };
 
-WX_DECLARE_LIST( dbgBreakPoint, dbgBreakPointList );
+WX_DECLARE_LIST(dbgBreakPoint, dbgBreakPointList);
 
 #endif
